#-------------------------------------------------
#
# Project created by QtCreator 2011-03-05T22:53:17
#
#-------------------------------------------------

QT       -= core
QT       -= gui

#CONFIG += win32
CONFIG += linux
#CONFIG += ps2
#CONFIG += dingoo_native
#CONFIG += dingux
#CONFIG += win32_cross # cross compiling win32 on linux using mingw32 (NOT FUNCTIONAL YET) #

CONFIG += console
CONFIG -= app_bundle

TARGET = rockbot

linux {
	LIBS = -L/usr/X11R6/lib \
		-lX11 \
		-lSDL_mixer \
		-lSDL_image \
                -lSDL_ttf \
                `sdl-config \
                --libs`

	INCLUDES = -I/usr/include/SDL \
		-I/usr/include \
		-I. \
		-I./include \
		-L/usr/lib
	QMAKE_CCFLAGS += -DLINUX -DPC -Wno-reorder
	QMAKE_CXXFLAGS += -DLINUX -DPC -Wno-reorder
}

win32 {
        LIBS =  -lSDL_mixer \
                -lSDL_image \
                -lSDL_ttf \
                                -lmingw32 -lSDLmain -lSDL -mwindows


		INCLUDES = -I/usr/include/SDL \
                -I/usr/include \
                -I. \
                -I./include \
                -L/usr/lib
		QMAKE_CCFLAGS += -DWIN32 -DPC
		QMAKE_CXXFLAGS += -DWIN32 -DPC
}

win32_cross {
		TARGET = rockbot.exe
		LIBS = `/opt/SDL-1.2.13/bin/sdl-config --libs` -lSDL_image -lSDL_ttf -lSDL_mixer

		INCLUDES = -I/opt/SDL-1.2.13/include \
				-I. \
				-I./include \
				-L/usr/lib

		QMAKE_CC = /opt/cross-tools/bin/i386-mingw32msvc-gcc
		QMAKE_CXX = /opt/cross-tools/bin/i386-mingw32msvc-g++
		QMAKE_LINK = /opt/cross-tools/bin/i386-mingw32msvc-ld
		QMAKE_CCFLAGS += -DWIN32 -DPC -I/opt/SDL-1.2.13/include `/opt/SDL-1.2.13/bin/sdl-config --cflags`
		QMAKE_CXXFLAGS += -DWIN32 -DPC -I/opt/SDL-1.2.13/include `/opt/SDL-1.2.13/bin/sdl-config --cflags`
}

dingux {
	TARGET = rockbot.dge

	QMAKE_CC = mipsel-linux-gcc
	QMAKE_CXX = mipsel-linux-g++
	QMAKE_LINK = mipsel-linux-g++

	QMAKE_CCFLAGS += -pipe -g -Wall -W -D_REENTRANT -DDINGUX -DHANDHELD
	QMAKE_CXXFLAGS += -I$(DINGUX_TOOLCHAIN_PREFIX)/include -pipe -g -Wall -W -D_REENTRANT -DDINGUX -DHANDHELD

	LIBS = $(SUBLIBS) -L$(DINGUX_TOOLCHAIN_PREFIX)/lib -lSDL_mixer -lSDL_image -lSDL_ttf `$(DINGUX_TOOLCHAIN_PREFIX)/bin/sdl-config --libs` -lpthread

	INCLUDES = -I$(DINGUX_TOOLCHAIN_PREFIX)/include -I. -I../include -I.
}



ps2 {
	TARGET = rockbot.elf

	SJPCM.target = SJPCM.s
	SJPCM.commands = bin2s ../ps2/SJPCM.irx ../ps2/SJPCM.s SJPCM

	cdvd.target = cdvd.s
	cdvd.commands = bin2s ../ps2/cdvd.irx ../ps2/cdvd.s cdvd

	usbd.target = usbd.s
	usbd.commands = bin2s ../ps2/usbd.irx ../ps2/usbd.s usbd

	usbhdfsd.target = usbhdfsd.s
	usbhdfsd.commands = bin2s ../ps2/usbhdfsd.irx ../ps2/usbhdfsd.s usbhdfsd

	QMAKE_EXTRA_TARGETS += SJPCM cdvd usbd usbhdfsd
	PRE_TARGETDEPS += SJPCM.s
	PRE_TARGETDEPS += cdvd.s
	PRE_TARGETDEPS += usbd.s
	PRE_TARGETDEPS += usbhdfsd.s

	INCLUDES = -DPLAYSTATION=1 -DNUM=100 -DUSE_RWOPS -I../include -I./include -I$(PS2SDK)/ports/include/SDL -I$(PS2SDK)/ports/include -I../common
	#LIBS = cdvd_rpc.o cdvd.s usbd.s usbhdfsd.s SJPCM.s -L. -lc -L$(PS2DEV)/gsKit/lib -L../lib -L$(PS2SDK)/ports/lib -lSDL_image -ljpeg -ltiff -lpng -lz -lm -lcdvd -ldebug -lSDL_ttf -lsdlmixer -lfreetype -lm -lcdvd -lsdl -lc -lm -lc -lsyscall -lkernel
	LIBS = -mno-crt0 -T/usr/local/ps2dev/ps2sdk/ee/startup/linkfile /usr/local/ps2dev/ps2sdk/ee/startup/crt0.o ../ps2/cdvd.s ../ps2/usbd.s ../ps2/usbhdfsd.s ../ps2/SJPCM.s -L. -lc -L$(PS2DEV)/gsKit/lib -L../lib -L$(PS2SDK)/ports/lib -lSDL_image -ljpeg -ltiff -lpng -lz -lm -ldebug -lSDL_ttf -lsdlmixer -lfreetype -lm -lcdvd -lsdl -lc -lm -lc -lsyscall -lkernel -L/usr/local/ps2dev/ps2sdk/ee/lib -L/usr/local/ps2dev/gsKit/lib -L/usr/local/ps2dev/ps2sdk/ports/lib


	QMAKE_CXX = ee-g++
	QMAKE_LINK = ee-g++

	QMAKE_CXXFLAGS += -D_STLP_NO_NAMESPACES -D_NOTHREADS -D_STLP_NO_EXCEPTIONS -D_STLP_USE_NEWALLOC -D_STLP_HAS_WCHAR_T -D_STLP_NO_IOSTREAMS -Dwint_t=int -I$(PS2SDK)/ports/include/stlport/ -DPLAYSTATION=1 -DNUM=100 -DPLAYSTATION=1 -DNUM=100 -DUSE_RWOPS -I../include -I./include -I$(PS2SDK)/ports/include/SDL -I$(PS2SDK)/ports/include -I../common -I $(PS2SDK)/ee/include -I $(PS2SDK)/common/include

	#LIBS = --sysroot=/arquivos/programas/devel/SDK/opendingux/opendingux-toolchain/ $(SUBLIBS) -L$(OPENDINGUX_TOOLCHAIN_PREFIX)/lib -lSDL_mixer -lSDL_image -lSDL_ttf `$(OPENDINGUX_TOOLCHAIN_PREFIX)/bin/sdl-config --libs` -lpthread -Wl,--gc-sections

	#INCLUDES = -I$(OPENDINGUX_TOOLCHAIN_PREFIX)/include -I. -I../include -I.
}


dingoo_native {
	TARGET = rockbot
	QMAKE_CC = mipsel-linux-gcc
	QMAKE_CXX = mipsel-linux-g++
	QMAKE_LINK = mipsel-linux-g++

	QMAKE_CCFLAGS += -pipe -g -Wall -W -D_REENTRANT -DDINGUX -DHANDHELD
	QMAKE_CXXFLAGS += -pipe -g -Wall -W -D_REENTRANT -DDINGUX -DHANDHELD -I$(DINGOO_SDK)/include -I$(DINGOO_SDK)/include/stlport/stl/config/ -I$(DINGOO_SDK)/include/stlport -I$(OPENDINGUX_TOOLCHAIN_PREFIX)/include

	LIBS = --sysroot=$(DINGOO_SDK) $(SUBLIBS)  -L$(DINGOO_SDK)/lib -lSDL_mixer -lSDL_image -lSDL_ttf `sdl-config --libs` -lpthread

	INCLUDES = -I$(DINGOO_SDK)/include -I. -I../include -I. -I$(OPENDINGUX_TOOLCHAIN_PREFIX)/include
}

open_pandora {
	TARGET = rockbot

	QMAKE_CCFLAGS += -pipe -g -Wall -W -D_REENTRANT -DOPEN_PANDORA -DHANDHELD
	QMAKE_CXXFLAGS += -pipe -g -Wall -W -D_REENTRANT -DOPEN_PANDORA -DHANDHELD

	LIBS = $(SUBLIBS)  -L$(DINGUX_TOOLCHAIN_PREFIX)/lib -lSDL_mixer -lSDL_image -lSDL_ttf `sdl-config --libs` -lpthread

	INCLUDES = -I. -I../include -I.
}


TEMPLATE = app


SOURCES += main.cpp \
    character.cpp \
    graphicslib.cpp \
    inputlib.cpp \
    game.cpp \
    stage.cpp \
    classmap.cpp \
    classplayer.cpp \
    timerlib.cpp \
    sceneslib.cpp \
    soundlib.cpp \
    projectilelib.cpp \
    classnpc.cpp \
    stage_select.cpp \
    class_config.cpp \
    objects/object.cpp \
    class_colorcycle.cpp \
    graphic/option_picker.cpp \
    scenes/dialogs.cpp \
    file/file_io.cpp \
    character/classboss.cpp \
    graphic/animation.cpp \
    scenes/ending.cpp \
    colision_detection.cpp

HEADERS += \
    character.h \
    st_hitPoints.h \
    st_platform.h \
    st_teleporter.h \
    st_common.h \
    st_characterState.h \
    st_projectile.h \
    graphicslib.h \
    defines.h \
    inputlib.h \
    game.h \
    stage.h \
    classmap.h \
    classplayer.h \
    timerlib.h \
    sceneslib.h \
    soundlib.h \
    projectilelib.h \
    classnpc.h \
    stage_select.h \
    class_config.h \
    objects/object.h \
    class_colorcycle.h \
    graphic/option_picker.h \
    scenes/dialogs.h \
    file/format.h \
    file/file_io.h \
    character/classboss.h \
    graphic/animation.h \
    scenes/ending.h \
    file/v_2_0_0.h \
    file/v_1.h \
    file/v_2_0_1.h \
    file/v_2_0_2.h \
    colision_detection.h \
    file/v_2_0_3.h

OTHER_FILES += \
    docs/RoadMap.txt \
    rockbot_dingux.pro









