#include <QtGui/QApplication>
#include <dirent.h>
#include "mediator.h"

int palleteX=0;
int palleteY=0;
Mediator *dataExchanger = new Mediator();
std::string FILEPATH;

#include "../file/format.h"
#include "editortilepallete.h"
#include "editorarea.h"
#include "mainwindow.h"

struct format_v1_0::file_game game;
char EDITOR_FILEPATH[512];

#include "../file/file_io.h"
CURRENT_FILE_FORMAT::file_game game_data;

void remove_duplicated()
{
	for (int i=0; i<MAX_STAGES; i++) {
		for (int j=0; j<STAGE_MAX_MAPS; j++) {
			// remove duplicated NPCS
			for (int k=0; k<MAX_MAP_NPC_N; k++) {
				for (int l=0; l<MAX_MAP_NPC_N; l++) {
					//game_data.stages[i].maps[j].map_npcs[k].id_npc != -1 && game_data.stages[i].maps[j].map_npcs[l].id_npc != -1 &&
					if (game_data.stages[i].maps[j].map_npcs[l].id_npc != -1 && k != l && game_data.stages[i].maps[j].map_npcs[k].start_point == game_data.stages[i].maps[j].map_npcs[l].start_point) {
						std::cout << ">>> removing duplicated NPC[" << l << "].id[" << game_data.stages[i].maps[j].map_npcs[l].id_npc << "] in stage[" << i << "].map[" << j << "] <<<" << std::endl;
						game_data.stages[i].maps[j].map_npcs[l].id_npc = -1;
						game_data.stages[i].maps[j].map_npcs[l].start_point.x = -1;
						game_data.stages[i].maps[j].map_npcs[l].start_point.y = -1;
					}
				}
			}
			// remove duplicated OBJECTS
			for (int k=0; k<MAX_MAP_NPC_N; k++) {
				for (int l=0; l<MAX_MAP_NPC_N; l++) {
					//game_data.stages[i].maps[j].map_objects[k].id_object != -1 && game_data.stages[i].maps[j].map_objects[l].id_object != -1 &&
					if (game_data.stages[i].maps[j].map_objects[l].id_object != -1 && k != l && game_data.stages[i].maps[j].map_objects[k].start_point == game_data.stages[i].maps[j].map_objects[l].start_point) {
						std::cout << ">>> BEFORE removing duplicated OBJECT stage[" << i << "].map[" << j << "].object[" << l << "].id: " << game_data.stages[i].maps[j].map_objects[l].id_object << " <<<" << std::endl;
						game_data.stages[i].maps[j].map_objects[l].id_object = -1;
						game_data.stages[i].maps[j].map_objects[l].start_point.x = -1;
						game_data.stages[i].maps[j].map_objects[l].start_point.y = -1;
						std::cout << ">>> AFTER removing duplicated OBJECT stage[" << i << "].map[" << j << "].object[" << l << "].id: " << game_data.stages[i].maps[j].map_objects[l].id_object << " <<<" << std::endl;
					}
				}
			}
		}
	}
}

#undef main
int main(int argc, char *argv[])
{
	std::string EXEC_NAME;
	#ifndef WIN32
		strncpy (EDITOR_FILEPATH, argv[0], strlen(argv[0])-7);
		EXEC_NAME = "editor";
	#else
        strncpy (EDITOR_FILEPATH, argv[0], strlen(argv[0])-11);
		EXEC_NAME = "editor.exe";
	#endif
	printf("*********** FILEPATH: '%s' **************\n", EDITOR_FILEPATH);

	std::string argvString = std::string(argv[0]);
	FILEPATH = argvString.substr(0, argvString.size()-EXEC_NAME.size());

	CURRENT_FILE_FORMAT::file_io fio;
	fio.read_game(game_data);


	dataExchanger->initGameVar();
    QApplication a(argc, argv);
    MainWindow w;
	w.resize(1024, 680);

	remove_duplicated();

	w.show();
    return a.exec();
}
