#ifndef V_2_0_2_H
#define V_2_0_2_H

#include <fstream>
#include <iostream>
#include "v_2_0_0.h"
#include "v_2_0_1.h"

extern std::string FILEPATH;

namespace format_v_2_0_2 {

	struct st_weakness {
		short weapon_id;									// weapon number of weakness, if -1, no weakness
		short damage_multiplier;							// how many time more damage is taken, if zero, no damage from this weapon is taken
		st_weakness() {
			weapon_id = -1;
			damage_multiplier = 1;
		}
	};

	struct file_npc { // DONE - Game
		short id;
		//unsigned int projectile_id;							// indicates the projectile ID (relation with file_projectile)
		short projectile_id[2]; // indicate the id of an attack the NCP can user
		char name[CHAR_NAME_SIZE];
		char graphic_filename[CHAR_FILENAME_SIZE];
		struct st_hit_points hp;
		short direction;              // defines how it behavies (kink of AI*)
		short speed;               // defines the distances it can see enemies
		short walk_range;                 // defines how long from the start point it can go
		short facing;                     // defines the side npc is facing before start moving (also used by LINEWALK behavior)
		struct st_position start_point;
		format_v2_0::st_sprite_info frames[NPC_FRAME_NUMBER];		// holds information about the type of each frame
		st_size frame_size;
		bool can_shoot;
		short shield_type;
		short IA_type;										// IA types: no_move, wait, attack, zig-zag (loop), side to side (origin to direction)
		short death_spawn;									// if different than -1, the NPC will spawn the given npc ID after killed
		st_weakness weakness[9];							// each npc have weaknesses for each boss weapon, plus the normal weapon
		char bg_graphic_filename[CHAR_FILENAME_SIZE];		// holds a static background
		st_position sprites_pos_bg;							// holds position of sprites in relation with background


		file_npc() {
			id = -1;
			name[0] = '\0';
			graphic_filename[0] = '\0';
			projectile_id[0] = -1;
			projectile_id[1] = -1;
			death_spawn = -1;
			bg_graphic_filename[0] = '\0';
		}
	};


	struct file_game {
		float version;
		char name[CHAR_NAME_SIZE];
		format_v_2_0_2::file_npc game_npcs[GAME_MAX_OBJS]; // 60 enemy types is more than good enought
		format_v2_0::file_object objects[GAME_MAX_OBJS];
		format_v2_0::file_projectile projectiles[MAX_FILE_PROJECTILES];
		format_v2_0::file_weapon weapons[MAX_WEAPON_N]; // 8 stage-bosses and 3 item-like
		format_v2_0::file_player players[MAX_FILE_PLAYERS]; // up to 5 different players the user can select from
		format_v_2_0_1::file_stage stages[MAX_STAGES];
		format_v2_0::file_artificial_inteligence ai_types[MAX_AI_TYPES];
		file_game() {
			/// *** hardcoded parts *** ///
			version = 0.92; // 0.9 means 1.0 beta, 0.92 means beta #2
			sprintf(name, "%s", "Rockbot");
		}
	};

}

#endif // V_2_0_2_H
